/* samDbUpdate: get user list from tbyscsuser					*/
/* Copyright (c) 2004-2005 yma system lab. All rights reserved.	*/
package model;
import org.apache.commons.logging.*;
import java.util.*;
import yscsoltp.yswebsvr.*;
import yscsoltp.ysapldata.*;

public class samDbUpdate {
	private	Log 	 log	= LogFactory.getLog(getClass());
	private static final int dispRecd	= 14;
	private static final int insRecd	= 10;

	public samDbUpdate(){}

	public int makeUpData(yswebSession mysess, HashMap<String, String> map) {
		int			retcode		= 0;
		ysadTblData tbldata 	= getTblData(mysess);

		List<List>   updatas  = getUpDatas(tbldata, map);	/* XVf[^̈	*/
		List<String> delflags = getDelFlags(tbldata, map);	/* 폜tÖ	*/

		tbldata.setUpdDatas(updatas);						/* XVf[^̐ݒ	*/
		tbldata.setDelFlags(delflags);						/* del flags̐ݒ	*/
		return retcode;
	}
	private List<List> getUpDatas(ysadTblData tbldata, HashMap<String, String> map) {
		List<List> 	updatas		= new ArrayList<List>();

		int 		rowcounts	= tbldata.getRowDatas().size();
		int 		clmcounts	= tbldata.getClmSizes().size();

		for(int i = 0; i < rowcounts; i++) {
			List<String> clmdatas = new ArrayList<String>();

			for(int j = 0; j < clmcounts; j++) {
				String  key = "data" + i + "." + j;			/* f[^L[		*/
				String  value = (String)map.get(key);		/* f[^̎擾		*/
				if (value == null) continue;
				clmdatas.add(value.trim());					/* f[^ݒ		*/
			}
			updatas.add(clmdatas);
		}
		return updatas;
	}
	private List<String> getDelFlags(ysadTblData tbldata, HashMap<String, String> map) {
		List<String> delflags	= new ArrayList<String>();

		int rowcounts	= tbldata.getRowDatas().size();		/* s̎擾		*/
		int clmcounts	= tbldata.getClmSizes().size();		/* ڐ̎擾		*/

		for(int i = 0; i < rowcounts; i++) {
			String delkey  = "delt" + i;					/* deletevL[	*/
			String deldata = map.get(delkey);

			if (deldata == null) deldata = "0";				/* ͖			*/
			else if (deldata.equals("1")) deldata = "1";	/* 폜w			*/
			else deldata = "0";
			delflags.add(deldata);							/* 폜ݒ	*/
		}
		return delflags;
	}

	public int dbUpdate(yswebSession mysess, HashMap<String, String> map) {
		int				retcode	= 0;

		ysadTblData tbldata 	= getTblData(mysess);
		makeUpData(mysess, map);						/* mʂł̕ύXf	*/

		ysadTblData tmpdata = null;
		tmpdata = mysess.dbAccess(tbldata, tbldata.reqUpdate);	/* f[^擾	*/
		if (tmpdata == null) retcode = -1;
		else retcode = tmpdata.getResult();

		return retcode;
	}

	private ysadTblData getTblData(yswebSession mysess) {
		return  (ysadTblData)mysess.getValue("tblData");
	}

	public int initInsert(yswebSession mysess) {		/* R[hǉ		*/
		int			retcode	= 0;
		List<List> 	updatas	= new ArrayList<List>();
		String		spaces	= "                                                          ";

		ysadTblData tbldata 	= getTblData(mysess);
		List<String> clmsizes 	= tbldata.getClmSizes();
		int			 clmcounts 	= clmsizes.size();

		for(int i = 0; i < insRecd; i++) {
			List<String> clmdatas = new ArrayList<String>();

			for(int j = 0; j < clmcounts; j++) {		/* Xy[X		*/
				int size = Integer.parseInt((String)clmsizes.get(j));
				clmdatas.add(null);
			}
			updatas.add(clmdatas);
		}
		tbldata.setUpdDatas(updatas);
		return retcode;
	}
	public int dbInsert(yswebSession mysess, HashMap<String, String> map) {
		int			retcode		= 0;
		List<List> 	updatas		= new ArrayList<List>();

		ysadTblData tbldata 	= getTblData(mysess);
		int			rowcounts	= tbldata.getUpdDatas().size();
		int			clmcounts	= tbldata.getClmNames().size();

		for(int i = 0; i < rowcounts; i++) {
			List<String> clmdatas = new ArrayList<String>();

			for(int j = 0; j < clmcounts; j++) {
				String  key = "data" + i + "." + j;
				String  value = (String)map.get(key).trim();/* ̓f[^擾	*/
				if (j == 0) {							/* 擪ڂɃf[^Ȃ	*/
					if (value == null) break;			/* ǉȂ			*/
					if (value.length() <= 0) break;
				}
				if (value == null) value = "0";			/* f[^̕[			*/
				else if (value.length() <= 0) value = "0";

				clmdatas.add(value);					/* ̓f[^ǉ		*/
			}
			if (clmdatas.size() == clmcounts) {
				updatas.add(clmdatas);
			}
		}
		tbldata.setUpdDatas(updatas);

		ysadTblData tmpdata = null;
		tmpdata = mysess.dbAccess(tbldata, tbldata.reqInsert);	/* DB		*/
		if (tmpdata == null) retcode = -1;
		else retcode = tmpdata.getResult();

		return retcode;
	}
}
